<?php

/**
 *
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

class irc_control
{
var $socket; //le socket
var $usercommand; //le champ gtkentry ac la commande de l'utilisateur
var $fp; //la ressource de fichier pour le log
var $currentmsg; //sert  recomposer des messages briss si msg socket trop long. efficacit non prouve
var $notebook; //le notebook ac les diffrents chans
var $channels = array(); //cle : nom du canal, val : objet channel = onglet du notebook
var $nick; //le nick de l'utilisateur
var $currentchannel; //ultra utile : maj quand on change de page
var $debugmode;
var $debugconsole;
var $debugentry;
var $timeouts = array();
var $window; //fentre principale
var $pvs = array(); //pareil que pour chans sauf que c pour les pvs
var $couleurs = array(); //les couleurs standard
var $performbuffer; //performbuffer, actions  excuter au dbut, tableau de commandes utilisateur
var $quizz; //le quizz en cours
	
	function irc_control($serveur, $port, $nick, $performbuffer = null, $incgm = false)
	{
		$this->performbuffer = $performbuffer;
		$nicks = explode(" ", $nick);
		$nick = $nicks[0];
		$this->nick = strtolower($nick);
		
		global $api;
		$api->sndPlaySound("ding.wav", 0);
	
		$this->couleurs['server'] = gdk::color_parse('#008040');
		$this->couleurs['default'] = gdk::color_parse('#004080');
		$this->couleurs['useraction'] = gdk::color_parse('#FF40FF');
		$this->couleurs['info'] = gdk::color_parse('#408080');
		$this->couleurs['op'] = gdk::color_parse('#FF0066');
		$this->couleurs['halfop'] = gdk::color_parse('#00CC99');
		$this->couleurs['voice'] = gdk::color_parse('#99CCFF');
		$this->couleurs['user'] = gdk::color_parse('#000000');
		$this->couleurs['usertext'] = gdk::color_parse('#FF0000');
		
		$this->couleurs['irc'][0] = gdk::color_parse('#FFFFFF');
		$this->couleurs['irc'][1] = gdk::color_parse('#000000');
		$this->couleurs['irc'][2] = gdk::color_parse('#000080');
		$this->couleurs['irc'][3] = gdk::color_parse('#008000');
		$this->couleurs['irc'][4] = gdk::color_parse('#FF0000');
		$this->couleurs['irc'][5] = gdk::color_parse('#008040');
		$this->couleurs['irc'][6] = gdk::color_parse('#800080');
		$this->couleurs['irc'][7] = gdk::color_parse('#FF8040');
		$this->couleurs['irc'][8] = gdk::color_parse('#FFFF00');
		$this->couleurs['irc'][9] = gdk::color_parse('#00FF00');
		$this->couleurs['irc'][10] = gdk::color_parse('#008080');
		$this->couleurs['irc'][11] = gdk::color_parse('#00FFFF');
		$this->couleurs['irc'][12] = gdk::color_parse('#0000FF');
		$this->couleurs['irc'][13] = gdk::color_parse('#FF00FF');
		$this->couleurs['irc'][14] = gdk::color_parse('#808080');
		$this->couleurs['irc'][15] = gdk::color_parse('#C0C0C0');
	
		$this->font = gdk::font_load('-adobe-helvetica-medium-r-normal--*-120-*-*-*-*-*-*,*');
		$this->fontnormal = gdk::font_load('-unknown-Arial-normal-r-normal--*-110-96-96-p-0-iso8859-1');
		$this->fontbold = gdk::font_load('-unknown-Arial-bold-r-normal--*-110-96-96-p-0-iso8859-1');
		
		$this->window = &new GtkWindow;
		$this->window->set_usize('640', '480');
		$this->window->set_title(translation("Fentre IRC"));
		$this->window->realize();
		$this->window->connect("destroy", "killwindow", &$this);
		
		$gbox = &new GtkVBox(false, 10);
		$gbox->set_border_width(10);
		$this->window->add($gbox);
		
		$this->notebook = &new GtkNotebook;
		$this->notebook->set_tab_pos(GTK_POS_TOP);
		$gbox->pack_start($this->notebook, true, true, 0);
		$this->notebook->realize();
		$this->new_notebook_page('status');
		
		$hbox = &new GtkHBox(false, 5);
		
		$this->usercommand = &new GtkEntry();
		
		$button1 = &new GtkButton(translation("Gras"));
		$hbox->pack_start($button1, false, false);
		$button2 = &new GtkButton(translation("Couleurs IRC"));
		$hbox->pack_start($button2, false, false);
		$button10 = &new GtkButton(translation("Quizz"));
        $hbox->pack_start($button10, false, false);
		$button11 = &new GtkButton(translation("Toolbox"));
        $hbox->pack_start($button11, false, false);
		$button12 = &new GtkButton(translation("Infos"));
        $hbox->pack_start($button12, false, false);

		
		$gbox->pack_start($hbox, false, false);
		$gbox->pack_start($this->usercommand, false, false);
		
		$this->window->show_all();
		
		$this->irc_connect($serveur, $port);
		
		$this->notebook->connect('switch_page', array(&$this, "page_switch"));
		$this->usercommand->connect_after("activate", array(&$this, "parse_user_msg"));
		$button1->connect("clicked", array(&$this, "insert"), "\x02", null, false);
		$button2->connect("clicked", array(&$this, "insert"), "\x03", null, false);
		$button10->connect("clicked", array(&$this, "quizz_select"));
		$button11->connect("clicked", array(&$this, "toolbox"));
		$button12->connect("clicked", array(&$this, "info_select"));
		
		$this->fp = fopen('../logs/irc.txt', 'a+');
		fputs($this->fp, "\r\n\r\n".translation("Nouvelle session")." : ".date("r")."\r\n");
		
		if (!file_exists("../irc_chatter/debug.lock")) {
			$debugwindow = &new GtkWindow;
			$debugwindow->set_usize('400', '300');
			$debugwindow->set_title("Debug");
			$debugwindow->connect("destroy", "destroy_window", &$this);
			
			$dgbox = &new GtkVBox(false, 10);
			$dgbox->set_border_width(10);
			$debugwindow->add($dgbox);
			
			$dhbox = &new GtkHBox;
			$this->debugconsole = &new GtkText;
			$dscrollbar = &new GtkVScrollbar($this->debugconsole->vadj);
			$this->debugconsole -> set_editable(false);
			$this->debugconsole -> set_word_wrap(true);
			$dhbox->pack_start($this->debugconsole, true, true, 5);
			$dhbox->pack_end($dscrollbar, false);
			$dgbox->pack_start($dhbox);
			
			$this->debugentry = &new GtkEntry();
			$dgbox->pack_start($this->debugentry, false, false);
			
			$debugwindow->show_all();
			
			$this->debugentry->connect_after("activate", array(&$this, "parse_debug_command"));
		}
		
		$this->timeouts[0] = gtk::timeout_add('20', array(&$this, "update_irc"));
		$this->timeouts[1] = gtk::timeout_add('2', array(&$this, "refresh"));
		
	}

	function insert($widget, $text, $window = null, $parse = true)
	{
		switch($text){
			case "date": 
				$text = date("l j F Y, H\hi");
				break;
			case "pub": 
				$text = "\x02"."\x03"."7 http://www.central-game.com";
				break;
			case "mem":
				$return = array(0 => translation("Informations mmoire"));
				exec("..\\irc_chatter\\memstat.exe", $return);
				$text = implode(" - ", $return);
				$text = str_replace("", "e", $text); //bug si essaye insrer 
				$text = str_replace("32e", "pourcent de la", $text); //le % passe pas
				break;
			case "proc":
				exec("..\\irc_chatter\\Proc.exe", $return);
				$proc = $return[0];
				$model = $return[1];
				$text = translation("Mon processeur est un")." {$return[0]}, {$return[1]}";
				break;
			case "tickcount":
				global $api;
				$ticks = $api->GetTickCount();
				$secs  = floor($ticks / 1000);
				$mins  = floor($secs / 60);
				$hours = floor($mins / 60);
				$mins  = $mins - ($hours*60);
				$text = translation("Mon PC est allume depuis")." $hours ".translation("heure(s)")." $mins ".translation("minute(s)");
				break;
			default:
				;
		} // switch
		$pos = strlen($this->usercommand->get_text());
		$this->usercommand->insert_text($text, $pos);
		if ($parse) {
		    $this->parse_user_msg();
		}
		
		if ($window) 
			$window->destroy();
	}
	
	function quizz_select($button)
	{
		$qprompt = &new GtkWindow(GTK_WINDOW_DIALOG);
		$qprompt->set_usize(56, 24);
		$qprompt->connect_object("destroy-event", array(&$qprompt, "destroy"));
		$qprompt->set_position(GTK_WIN_POS_CENTER);
		
		$menu = &new GtkMenu;		
		$rep = opendir("../irc_chatter/");
		
		while($file = readdir($rep)){
			$pos = strlen($file) - 4;
			if (substr($file, $pos, 4) == ".cgm") {
				$menuitem = &new GtkMenuItem($file);
				$menuitem->show();
				$menuitem->connect_object('activate', array(&$this, 'create_new_quizz'), $file, &$qprompt);
				$menu->append($menuitem);
			}
		}
		
		closedir($rep);
		
		$combobutton = &new GtkComboButton($menu);
		$combobutton->set_arrow_direction(1);
		
		$qprompt->add($combobutton);
		
		$qprompt->show_all();
	}
	
	function info_select($button)
	{
		$qprompt = &new GtkWindow(GTK_WINDOW_DIALOG);
		$qprompt->set_usize(56, 24);
		$qprompt->connect_object("destroy-event", array(&$qprompt, "destroy"));
		$qprompt->set_position(GTK_WIN_POS_CENTER);
		
		$menu = &new GtkMenu;		
		
		$infos = array(translation("Date / heure") => "date",
		translation("Visitez Central-game.com") => "pub",
		translation("Infos mmoire") => "mem",
		translation("Infos processeur") => "proc",
		translation("Temps PC allum") => "tickcount");
		
		foreach ($infos as $cle => $val)
		{
				$menuitem = &new GtkMenuItem($cle);
				$menuitem->show();
				$menuitem->connect('activate', array(&$this, 'insert'), $val, &$qprompt);
				$menu->append($menuitem);
		}		
		
		$menuitem = &new GtkMenuItem(translation("Infos disque"));
		$menuitem->show();
		$menuitem->connect('activate', array(&$this, 'prompt'), "disque", &$qprompt);
		$menu->append($menuitem);
				
		$combobutton = &new GtkComboButton($menu);
		$combobutton->set_arrow_direction(1);
		
		$qprompt->add($combobutton);
		
		$qprompt->show_all();
	}
	
	function toolbox($button)
	{
		$tprompt = &new GtkWindow(GTK_WINDOW_POPUP);
		$tprompt->set_usize(288, 35);
		$tprompt->set_position(GTK_WIN_POS_MOUSE);
		$tprompt->connect_object("destroy-event", array(&$tprompt, "destroy"));
		$tprompt->set_name("popupwindow");
		$tprompt->set_border_width(5);
		
		$hbox = &new GtkHBox(false, 5);
		
		$button5 = &new GtkButton(translation("Action"));
		$hbox->pack_start($button5, false, false);
		$button6 = &new GtkButton(translation("Rejoindre"));
        $hbox->pack_start($button6, false, false);
		$button7 = &new GtkButton(translation("Pseudo"));
        $hbox->pack_start($button7, false, false);
		$button8 = &new GtkButton(translation("Priv"));
        $hbox->pack_start($button8, false, false);
		$button9 = &new GtkButton(translation("Kick (OP)"));
        $hbox->pack_start($button9, false, false);
		$button10 = &new GtkButton(translation("Fermer"));
        $hbox->pack_start($button10, false, false);
		
		$button5->connect("clicked", array(&$this, "insert"), "/me", null, false);
		$button6->connect("clicked", array(&$this, "prompt"), "newchan");
		$button7->connect("clicked", array(&$this, "prompt"), "newnick");
		$button8->connect("clicked", array(&$this, "insert"), "/msg pseudo message", null, false);
		$button9->connect("clicked", array(&$this, "insert"), "/kick user ".translation("raison du kick"), null, false);
		$button10->connect_object("clicked", array(&$tprompt, "destroy"));
		
		$tprompt->add($hbox);
		
		$tprompt->show_all();
	}
	
	function create_new_quizz($file, $w)
	{
		if ($this->quizz) {
		    $this->display(translation("Erreur : un quizz est dj lanc. Tapez !stop pour arrter le quizz")."\r\n", "info", $this->currentchannel);
		}
		else
		{
			$this->quizz = &new quizz($file, $this->currentchannel, &$this);
		}
		$w->destroy();
	}
	
	function prompt($button, $type, $window=null)
	{
		if ($window) {
		    $window->destroy();
		}
		$prompt = &new GtkWindow(GTK_WINDOW_DIALOG);
		$prompt->set_usize(48, 18);
		
		$prompttext = &new GtkEntry();
		$prompt->add($prompttext);
		if ($type == translation("disque")) {
		    $prompttext->set_text("c:\\");
		}
		$prompttext->connect_after('activate', array(&$this, "validate_prompt"), $type, &$prompt);
		
		$prompt->show_all();
	}
	
	function validate_prompt($widget, $type, &$window)
	{
		$text = $widget->get_text();
		$window->destroy();
		switch($type){
			case "newnick": 
				$this->usercommand->set_text("/nick $text");
				$this->parse_user_msg();
				break;
			case "newchan": 
				$this->usercommand->set_text("/join $text");
				$this->parse_user_msg();
				break;
			case "disque":
				$espace = disk_free_space($text)/pow(1024, 3);
				$espace = round($espace, 2);
				$this->insert(null, translation("Espace disponible sur")." $text : $espace Go");
				$this->parse_user_msg();
				break;
			default:
				;
		} // switch
	}
	
	function parse_debug_command($widget)
	{
		$command = $this->debugentry->get_chars(0, -1);
		$this->parse_server_msg($command);
	}
	
	function display($text, $type=null, $channel="status")
	{
		$channel = strtolower($channel);
		array_key_exists($channel, $this->channels) ? null : ($this->channels[$channel] = null);
		if (!$this->channels[$channel])
		{
		    $channel = "status";
		}
		switch($type){
				case 'server' : 
					$fg1 = $this->couleurs['server'];
					break;
				case 'user' : 
					$fg1 = $this->couleurs['user'];
					break;
				case 'useraction' : 
					$fg1 = $this->couleurs['useraction'];
					break;
				case 'usertext' : 
					$fg1 = $this->couleurs['usertext'];
					break;
				case 'info' : 
					$fg1 = $this->couleurs['info'];
					break;
				default:
					$fg1 = null;
		} // switch
		
		/* *explications sur ce bloc
		* totalement rcrit
		* on examine chaque caractre 
		* pour les caractres spciaux
		* on maj les proprits
		* mais qui ne seront changes qu'aprs l'insertion
		* cd quand il y a modif de la police, weight, couleur
		* etc. on demande d'afficher
		* et aprs avoir affich le texte prcdent on maj
		* pour le prochain affichage
		* efficacit optimale ^^
		* */
		$gras = false;
		$font = $this->fontnormal;
		$k = 0;
		$insertfg = $fg1;
		$insertbg = null;
		$fg = $fg1;
		$bg = null;
		$afficher = false;
		$text = $text."\x02";
		$codelen = 0;
		$inserttext = null;
		$nextfont = null;
		while($k <= strlen($text))
		{
			$lettre = @isset($text[$k]) ? $text[$k] : null;
			switch($lettre){
				case "\x02": 
					switch($gras){
						case false : 
							$gras = true;
							$nextfont = $this->fontbold;
							break;
						case true : 
							$gras = false;
							$nextfont = $this->fontnormal;
							break;
					} // switch
					$afficher = true;
					break;
				case "\x03": 
					if (preg_match("/\03([0123456789]{1,2})((,([0123456789]{1,2}))|)/", substr($text, $k, 6), $couleurs)) {
					 
					 	@isset($couleurs[1]) ? null : ($couleurs[1] = null);
					 	@isset($couleurs[4]) ? null : ($couleurs[4] = null);
						$fg = ($couleurs[1] !== null) ? $this->couleurs['irc'][$couleurs[1]] : $fg1;
						$bg = ($couleurs[4] !== null) ? $this->couleurs['irc'][$couleurs[4]] : null;
						
						$codelen = strlen($couleurs[0]) - 1;
					}
					$afficher = true;
					break;
				default:
					if ($codelen > 0) {
					    $codelen--;
					}
					else
					{
						$inserttext .= $lettre;
					}
			} // switch
			
			if ($afficher) {	
				$this->channels[$channel]->console->insert($font, $insertfg, $insertbg, $inserttext);
				$inserttext = null;
				$afficher = false;
				$font = $nextfont;
				$insertfg = $fg;
				$insertbg = $bg;
			}
			
			$k++;
		}
		$this->channels[$channel]->pixwid->set($this->channels[$channel]->msg_on[0], $this->channels[$channel]->msg_on[1]);
	}
	
	function display_pv($text, $pv, $is_user=false)
	{
		$couleur = $is_user ? $this->couleurs['usertext'] : $this->couleurs['user'];
		$this->pvs[$pv]->console->insert(null, $couleur, null, $text);
	}
	
	function irc_connect($server, $port)
	{
		if (($this->socket = socket_create(AF_INET,SOCK_STREAM,SOL_TCP)) < 0)
		{
			$this->display("socket_create() failed: reason: ".socket_strerror ($this->socket)."\r\n");
		}
		else
		{
			$this->display(translation("Tentative de connexion ")." $server ".translation("sur le port")." $port\r\n", 'info'); 
		}
		/*
		* if (($sock = socket_create (AF_INET, SOCK_STREAM, 0)) < 0) {
		    echo "socket_create() failed: reason: " . socket_strerror ($sock) . "\n";
		}
		
		if (($ret = socket_bind ($sock, $address, $port)) < 0) {
		    echo "socket_bind() failed: reason: " . socket_strerror ($ret) . "\n";
		}
		
		if (($ret = socket_listen ($sock, 5)) < 0) {
		    echo "socket_listen() failed: reason: " . socket_strerror ($ret) . "\n";
		}

		*/
		
		socket_connect($this->socket,$server,intval($port)); 
		socket_set_nonblock($this->socket);
		$this->send("USER PHPGTK UNKNOW UNKNOW :".$this->nick."\r\n");
		$this->send("NICK :".$this->nick."\r\n");
		$this->server = $server;
		return true;
	}
	
	function send($msg)
	{
		socket_write($this->socket, $msg, strlen($msg)); 
	}
	
	function parse_special_command($command, $chan, $user=null)
	{
		if (strpos($command, "!meteo") === 0 && !file_exists("../irc_chatter/bot.lock")) {
			$chan = strtolower($chan);
		    $fp = fopen("http://www.lachainemeteo.com/ObsPrev.asp?Zone=France&CodeZone=fran&TypeCarte=Prev&Carte=NebTmp&Tmps=0PM", "r");
			while(!feof($fp)){
				$contenu .= fread($fp, 4096);
			} // while
			fclose($fp);
			
			$meteo = array();
			preg_match("/<IMG SRC=\"\/ImagesLCM\/franNebP0PM\.jpg\">(.+)<IMG SRC=\"\/ImagesLCM\/franTmpP0PM\.jpg\">/", $contenu, $meteo);
			$meteo[1] = preg_replace("/<([^>]+)>/", "", $meteo[1]);
			$command = "PRIVMSG $chan :".$meteo[1];
			//echo $command;
			$this->send($command);
		}
		
		if ($this->quizz) {
		    $this->quizz->try_response($command, $user);
		}
		
		if (strpos($command, "!points") === 0) {
			$this->quizz->points($user);
		}
	}
	
	function parse_server_msg($servermsg)
	{
	fputs($this->fp, "$servermsg\r\n");	
	$dejaaffiche = false;
	
	while(gtk::events_pending()) gtk::main_iteration(); //est-ce que a sert ?
	
	$commande = explode(':', trim($servermsg), 3);
	
		switch(strtoupper($commande[0])){
			case "PING ": 
				$reponse = "PONG ".$commande[1]."\r\n";
				$this->display($reponse, 'info');
				$this->send($reponse);
				break;
				/* certains serveurs ont la forme
				* :server!truc@machin.com NOTICE AUTH : votre message
				* ce cas est prvu dans le deuxime switch
				* pour le cas "normal" qui fait
				* NOTICE AUTH : patati patata
				* c le code qui suit
				*/
			case "NOTICE AUTH ":
				$this->display($commande[1]."\r\n", 'info');
				$dejaaffiche = true;
				break;
			case "NOTICE ":
				$this->display($commande[1]."\r\n", 'info');
				$dejaaffiche = true;
				break;
			default:
				//echo '';
		} // switch
		
		$action = explode(' ', trim($commande[1]));
		
		@isset($action[1]) ? null : ($action[1] = null);
		
		switch (strtoupper($action[1])) {
			case 'MODE':
				//if (strstr("#", $action[2]))
				if (isset($action[4])) //cette 2 mthode marche mais pas la premire je sais pas pk
				{
					$this->display($action[4]." ".translation("a maintenant le mode")." ".$action[3]." ".translation("sur le canal")." ".$action[2]."\r\n", 'server', $action[2]);
					
					$j = 0;
					$k = 0;
					$l = 0;
					$m = 0;
					$unsortedmodes = substr($action[3], 1);
					$sort = "aqohviswbx";
					$modes = null;
					//on trie par priorits 
					while($l <= strlen($sort)){
						if (@strstr($unsortedmodes, $sort[$l])) {
						    $modes .= $sort[$l];
						}
						$l++;
					} // while
					
					while($k <= strlen($modes))
					{
						$val = @isset($modes[$k]) ? $modes[$k] : null;
						//on parcourt tous les modes appliqu  l'utilisateur
						if (substr($action[3], 0, 1) == "+") {
						    switch($val){
								case "o" : 
									$this->remove_user($action[4+$j], $action[2]);
									$this->update_users("@".$action[4+$j], $action[2]);
									break;
								case "h" : 
									//on vrifie qu'il est pas dj op
									if (!$this->channels[$action[2]]->users["@".$action[4+$j]])
									{
										$this->remove_user($action[4+$j], $action[2]);
										$this->update_users("%".$action[4+$j], $action[2]);
									}
									break;
								case "v" : 
									//pas dj op ou halfop
									if (!$this->channels[$action[2]]->users["@".$action[4+$j]] && !$this->channels[$action[2]]->users["%".$action[4+$j]])
									{
										$this->remove_user($action[4+$j], $action[2]);
										$this->update_users("+".$action[4+$j], $action[2]);
									}
									break;
								default:
									;
							} // switch
						}
						if (substr($action[3], 0, 1) == "-") {
						    switch($val){
								case "o" :
									$this->remove_user($action[4+$j], $action[2]);
									$this->update_users("%".$action[4+$j], $action[2]);
									break;
								case "h" : 
									if (!$this->channels[$action[2]]->users["@".$action[4+$j]])
									{
										$this->remove_user($action[4+$j], $action[2]);
										$this->update_users("+".$action[4+$j], $action[2]);
									}
									break;
								case "v" : 
									if (!$this->channels[$action[2]]->users["@".$action[4+$j]] && !$this->channels[$action[2]]->users["%".$action[4+$j]])
									{
										$this->remove_user($action[4+$j], $action[2]);
										$this->update_users($action[4+$j], $action[2]);
									}
									break;
								default:
									;
							} // switch
						}//if
						$j++;
						$k++;
					}//foreach
				}
				else
				{
					$explode = explode(' ', $servermsg);
					$this->display($action[2]." ".translation("a maintenant le mode")." ".$explode[3]."\r\n", 'server', $action[2]);
				}
				break;
			case 'NOTICE':
				$this->display($commande[2]."\r\n", 'info');
				break;
			case 'PRIVMSG':
				$user = explode('!',$action[0]);
				if (strcasecmp($action[2], $this->nick)) {//msg pour un chan "normal"
					if (strpos($commande[2], "\x01"."ACTION") === 0) {
						$commande[2] = str_replace("\x01"."ACTION", "", $commande[2]);
						$commande[2] = str_replace("\x01", "", $commande[2]);
					    $this->display($user[0]." ".$commande[2]."\r\n", 'useraction', $action[2]);
					}
					else
					{
				    	$this->display($user[0].": ".$commande[2]."\r\n", 'user', $action[2]);
						$this->parse_special_command($commande[2], $action[2], $user[0]);
					}
				}
				else //c un pv
				{
					if (!$this->pvs[$user[0]]) {
					    $this->pvs[$user[0]] = &new pv($user[0], &$this);
					}
					$this->display_pv($user[0].": ".$commande[2]."\r\n", $user[0]);
				}
				break;
			case 'JOIN':
				/*
				* pour quoi re-exploder la chane du serveur ?
				* certains messages ont la forme : !user@serv.com JOIN #chan
				* et non pas !user@serv.com JOIN :#chan
				* donc l tous les cas possible sont englobs
				*/
				$user = explode('!',$action[0]);
				$explode = explode(' ', $servermsg);
				$explode[2] = str_replace(":", "", $explode[2]);
				$explode[2] = strtolower($explode[2]);
				$this->display($user[0]." ".translation("a rejoint")." ".$explode[2]."\r\n", 'server', $explode[2]);
				if ($this->channels[$explode[2]]) $this->update_users($user[0], $explode[2]);
				//prvention des bugs pour le if
				break;
			case 'QUIT':
				/* *
				* mm remarque que pour le join
				* */
				$user = explode('!',$action[0]);
				$explode = explode(' ', $servermsg, 3);
				$explode[2] = str_replace(":", "", $explode[2]);
				$explode[2] = strtolower($explode[2]);
				$this->remove_user($user[0], null, $explode[2]);
				break;
			case 'KICK':
				$user = explode('!',$action[0]);
				$this->remove_user($action[3], $action[2]);
				if ($action[3] == $this->nick) {
				    $this->channels[$action[2]]->remove_page(null, &$this, null);
					$this->display(translation("Vous avez t kick de")." ".$action[2]." ".translation("par")." ".$user[0].". ".translation("Raison")." : ".$commande[2]."\r\n", 'info');
				}
				else
				{
					$this->display($user[0]." ".translation("a kick")." ".$action[3]." ".translation("de")." ".$action[2].". ".translation("Raison")." : ".$commande[2]."\r\n", 'server', $action[2]);
				}
				break;
			case 'PART':
				$user = explode('!',$action[0]);
				$explode = explode(' ', $servermsg);
				$explode[2] = str_replace(":", "", $explode[2]);
				$explode[2] = strtolower($explode[2]);
				
				$this->remove_user($user[0], $explode[2]);
				$this->display($user[0]." ".translation("a quitt")." ".$explode[2]."\r\n", 'server', $explode[2]);
				break;
			case 'NICK':
				$user = explode('!',$action[0]);
				$this->change_user($user[0], $commande[2]);
				break;
			case '332': //topic
				$user = explode('!',$action[0]);
				$this->display(translation("Topic de")." ".$action[3]." : ".$commande[2]."\r\n", 'server', $action[3]);
				break;
			case '353': //liste des utilisateurs
				$user = explode('!',$action[0]);
				$this->display(translation("Utilisateurs sur")." ".$action[4]." : ".$commande[2]."\r\n", 'server', $action[4]);
				$cle = strtolower($action[4]);
				if ($this->channels[$cle]) $this->update_users($commande[2], $cle);
				//longtemps eu bcp de bugs  ce niveau, le if en vite
				break;
			case '433' : //nickname already in use
				$this->display(translation("Erreur 433 : pseudo dj utilis")."\r\n", 'info');
				srand((double)microtime()*1000000);
				$j = 0;
				$str = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
				$newnick = "phpgtk_";
				while($j <= 8) {
					$char = rand(0, strlen($str));
					$newnick .= @isset($str[$char]) ? $str[$char] : null;
					$j++;
				} // while
				$this->nick = $newnick;
				$this->send("NICK :$newnick\r\n");
				break;
			case '432' : //pseudo ircop lol
				$this->display(translation("Erreur 432 : pseudo IRCop")."\r\n", 'info');
				srand((double)microtime()*1000000 );
				$j = 0;
				$str = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
				$newnick = "phpgtk_";
				while($j <= 8) {
					$char = rand(0, strlen($str));
					$newnick .= $str[$char];
					$j++;
				} // while
				$this->nick = $newnick;
				$this->send("NICK :$newnick\r\n");
				break;
			case '333' ://topic set by ... x seconds ago
				$this->display(translation("Topic de")." ".$action[3]." ".translation("mis par")." ".$action[4]." ".translation("il y a")." ".$action[5]." ".translation("secondes")."\r\n", 'info', $action[3]);
				break;
			case '005' ://les paramtres dont nicklen
				if ($debut = strpos($servermsg, "NICKLEN")) {
				    $nicklen = trim(substr($servermsg, $debut+8, 2));
					$this->nick = substr($this->nick, 0, $nicklen);
				}
				$this->display($servermsg."\r\n", 'info');
				break;
			case 'TOPIC' :
				$user = explode('!',$action[0]);
				$this->display($user[0]." ".translation("a chang le topic de")." ".$action[2]." ".translation("pour")." ".$commande[2]."\r\n", 'server', $action[2]);
				break;
			case '001' :
				/* *hmm
				* juste que quand on reoit le code 001 a veut dire
				* qu'on est logg et tout donc je peux faire pter
				* le performbuffer
				* */
				if ($this->performbuffer) {
					foreach ($this->performbuffer as $cle => $val)
						{
							$this->usercommand->set_text($val);
					    	$this->parse_user_msg();
							$this->performbuffer[$cle] = null;
						}
				}
				$this->display($servermsg."\r\n", 'info');
				break;
			default:
				if (!$dejaaffiche)
				    $this->display($servermsg."\r\n", 'info');
		} // 
	}
	
	function update_irc()
	{
		if ($datairc = @socket_read($this->socket, 16384)) {
		    $stack = explode("\r\n", trim($datairc));
			$stack[0] = $this->currentmsg.$stack[0];
			$this->currentmsg = null;
			foreach ($stack as $cle => $servermsg)
			{
				if ($this->debugconsole) {
				    $this->debugconsole->insert(null, $this->colorserver, null, $servermsg."\r\n");
				}
				$this->parse_server_msg($servermsg);
				 /*
				 * 
				 * 				if (strlen($datairc) >= 20480)
				 * 			    	$this->currentmsg = $servermsg;
				 * 				else
				 * 			    	$this->currentmsg = null;
				 * 
				 * code  l'efficacit douteuse... de tte faon j'ai augment
				 * la quantit de donnes  lire du socket
				 */ 
			}
		}
		/*while ($servermsg = @socket_read($this->socket, 16384, PHP_NORMAL_READ)) {
		   
			if ($this->debugconsole) {
			    $this->debugconsole->insert(null, $this->colorserver, null, $servermsg."\r\n");
			}
			$this->parse_server_msg($servermsg);
		}*/
		$datairc = null;
		return true;
	}
	
	function refresh()
	{
		$this->channels[$this->currentchannel]->console->thaw();
		while (gtk::events_pending()) gtk::main_iteration();
		return true;
	}
	
	function quit()
	{
		$this->send("QUIT :http://central-game.jeuxfusion.com/cgm/ client irc en *php* open source");
		//echo "socket ferme\r\n";
		socket_close($this->socket);
		fclose($this->fp);
	}
	
	function parse_user_msg()
	{
		$command = $this->usercommand->get_chars(0, -1);
		$this->usercommand->set_text("");
		$action = explode(' ', $command, 3);
		switch(strtolower($action[0])){//allez hop insensible  la case ;)
			case '/join':
				$this->new_notebook_page($action[1]);
				$newcommand = "JOIN ".$action[1];
				break;
			case '/kick' :
				$newcommand = "KICK ".$this->currentchannel." ".$action[1]." :".$action[2];
				break;
			case '/nick':
				$newcommand = "NICK :".$action[1];
				$this->nick = $action[1];
				break;
			case '/raw':
				$newcommand = $action[1]." ".$action[2];
				break;
			case '/msg':
				$newcommand = "PRIVMSG ".$action[1]." :".$action[2];
				break;
			case '/debug':
				print_r($this->channels);
				echo $this->currentchannel."\r\n";
				break;
			case '/me':
				$action2 = explode(' ', $command, 2);
				$newcommand = "PRIVMSG ".$this->currentchannel." :"."\x01"."ACTION ".$action2[1]."\x01";
				$this->display($this->nick." ".$action2[1]."\r\n", 'useraction', $this->currentchannel);
				break;
			case '!stop':
				$this->quizz->end_quizz();
				$this->quizz = null;
				break;
			default:
				$this->display($this->nick.": ".$command."\r\n", 'usertext', $this->currentchannel);
				$newcommand = "PRIVMSG ".$this->currentchannel." :".$command;
				fputs($this->fp, "$newcommand\r\n");	
		} // switch
		//echo $newcommand."\r\n";
		if (isset($newcommand)) {
		    $this->send($newcommand."\r\n");
		}
	}
	
	function change_user($user, $newnick, $prefix2 = false, $canal = null)
	{
	$user = trim($user);
	$newnick = trim($newnick);
	
		foreach ($this->channels as $cle => $channel)
			{
				if ($this->channels[$cle]->users[$user] || $this->channels[$cle]->users["+".$user] || $this->channels[$cle]->users["%".$user] || $this->channels[$cle]->users["@".$user]) {
					$this->channels[$cle]->userlist->clear();
					
					if ($this->channels[$cle]->users[$user]) {
					    $this->channels[$cle]->users[$user] = 0;
						$prefix = null;
					}
					
					if ($this->channels[$cle]->users["+".$user]) {
					    $this->channels[$cle]->users["+".$user] = 0;
						$prefix = "+";
					}
					
					if ($this->channels[$cle]->users["@".$user]) {
					    $this->channels[$cle]->users["@".$user] = 0;
						$prefix = "@";
					}
					
					if ($this->channels[$cle]->users["%".$user]) {
					    $this->channels[$cle]->users["%".$user] = 0;
						$prefix = "%";
					}
					//tous ces blocs if pour prserver le prfix qui est conserv dans la liste des nicks
					
					if ($prefix2 && strtolower($cle) == strtolower($canal))//quand c un changement de mode on prcise le nv prefix
						$prefix = $prefix2;
					if ($prefix2 == "vide") //on met vide au moment du mode -v uniquement
						$prefix = null;
					
					//pour les nicks @op ou +voice etc..
					$this->channels[$cle]->i++;
				    $this->channels[$cle]->users[$prefix.$newnick] = $this->channels[$cle]->i;		
					$this->channels[$cle]->users = array_flip($this->channels[$cle]->users);
					natcasesort($this->channels[$cle]->users);
					$this->channels[$cle]->users = array_flip($this->channels[$cle]->users);
					
					//on redessine la liste
					foreach ($this->channels[$cle]->users as $cle2 => $val)
					{
						if ($val)
						{
							switch($cle2[0]){
								case '@': 
									$tempcolor = $this->couleurs['op'];
									$cle2 = substr($cle2, 1);
									break;
								case '%': 
									$tempcolor = $this->couleurs['halfop'];
									$cle2 = substr($cle2, 1);
									break;
								case '+': 
									$tempcolor = $this->couleurs['voice'];
									$cle2 = substr($cle2, 1);
									break;
								default:
									$tempcolor = $this->couleurs['default'];
							} // switch
							$this->channels[$cle]->userlist->Append(array($cle2)); 
							$cle2 = trim($cle2);
							$this->channels[$cle]->userlist->set_foreground(($this->channels[$cle]->userlist->rows - 1), $tempcolor);
						}
					}
					
					if (!$prefix2) //c'est pas un changement de mode
					    $this->display($user." ".translation("est maintenant")." ".$newnick."\r\n", "server", $cle);
					
				}
			}
	}
	
	function remove_user($user, $chan=null, $raison=null)
	{
	$chan = strtolower($chan);
	
		if ($chan) {
		    $this->channels[$chan]->users[$user] = 0;
		    $this->channels[$chan]->users["+".$user] = 0;
		    $this->channels[$chan]->users["%".$user] = 0;
		    $this->channels[$chan]->users["@".$user] = 0;
			$this->channels[$chan]->userlist->clear();
			$this->channels[$chan]->users = array_flip($this->channels[$chan]->users);
			natcasesort($this->channels[$chan]->users);
			$this->channels[$chan]->users = array_flip($this->channels[$chan]->users);
			foreach ($this->channels[$chan]->users as $cle => $val)
			{
				if ($val) 
				{
					switch($cle[0]){
						case '@': 
							$tempcolor = $this->couleurs['op'];
							$cle = substr($cle, 1);
							break;
						case '%': 
							$tempcolor = $this->couleurs['halfop'];
							$cle = substr($cle, 1);
							break;
						case '+': 
							$tempcolor = $this->couleurs['voice'];
							$cle = substr($cle, 1);
							break;
						default:
							$tempcolor = $this->couleurs['default'];
					} // switch
					$this->channels[$chan]->userlist->Append(array($cle)); 
					$cle = trim($cle);
					$this->channels[$chan]->userlist->set_foreground(($this->channels[$chan]->userlist->rows - 1), $tempcolor);
				}
			} 
		}
		else
		{
			foreach ($this->channels as $cle => $channel)
			{
				if ($this->channels[$cle]->users[$user] || $this->channels[$cle]->users["+".$user] || $this->channels[$cle]->users["%".$user] || $this->channels[$cle]->users["@".$user]) {
					$this->channels[$cle]->userlist->clear();
				    $this->channels[$cle]->users[$user] = 0;
		    		$this->channels[$cle]->users["+".$user] = 0;
		    		$this->channels[$cle]->users["%".$user] = 0;
		    		$this->channels[$cle]->users["@".$user] = 0;
					$this->channels[$cle]->users = array_flip($this->channels[$cle]->users);
					natcasesort($this->channels[$cle]->users);
					$this->channels[$cle]->users = array_flip($this->channels[$cle]->users);
					
					foreach ($this->channels[$cle]->users as $cle2 => $val)
					{
						if ($val)
						{
							switch($cle2[0]){
								case '@': 
									$tempcolor = $this->couleurs['op'];
									$cle2 = substr($cle2, 1);
									break;
								case '%': 
									$tempcolor = $this->couleurs['halfop'];
									$cle2 = substr($cle2, 1);
									break;
								case '+': 
									$tempcolor = $this->couleurs['voice'];
									$cle2 = substr($cle2, 1);
									break;
								default:
									$tempcolor = $this->couleurs['default'];
							} // switch
							$this->channels[$cle]->userlist->Append(array($cle2)); 
							$cle2 = trim($cle2);
							$this->channels[$cle]->userlist->set_foreground(($this->channels[$cle]->userlist->rows - 1), $tempcolor);
						}
					}
				$this->display($user." ".translation("a t dconnect(e) du serveur. Raison :")." ".$raison."\r\n", 'server', $cle);
				}
			}
		}
	}
	
	function update_users($list, $channel2)
	{
		//prparation
		$channel2 = strtolower($channel2);
		$this->channels[$channel2]->userlist->clear();
		$userlist = explode(' ', trim($list));
		
		foreach ($userlist as $cle => $val)
		{
			$this->channels[$channel2]->i++;
			$this->channels[$channel2]->users[$val] = $this->channels[$channel2]->i;
		}
		
		//bloc tri
		$this->channels[$channel2]->users = array_flip($this->channels[$channel2]->users);
		natcasesort($this->channels[$channel2]->users);
		$this->channels[$channel2]->users = array_flip($this->channels[$channel2]->users);
		
		foreach ($this->channels[$channel2]->users as $cle => $val)
		{
			//echo $this->channels[$channel2]->userlist->rows;
			if ($val) {
				switch($cle[0]){
					case '@': 
						$tempcolor = $this->couleurs['op'];
						$cle = substr($cle, 1);
						break;
					case '%': 
						$tempcolor = $this->couleurs['halfop'];
						$cle = substr($cle, 1);
						break;
					case '+': 
						$tempcolor = $this->couleurs['voice'];
						$cle = substr($cle, 1);
						break;
					default:
						$tempcolor = $this->couleurs['default'];
				} // switch
				$cle = trim($cle);
				$this->channels[$channel2]->userlist->Append(array($cle)); 
				$this->channels[$channel2]->userlist->set_foreground(($this->channels[$channel2]->userlist->rows - 1), $tempcolor);
			}
		}
		
		$this->channels[$channel2]->userlist->thaw();
		$this->channels[$channel2]->userlist->columns_autosize();
	}
	
	function new_notebook_page($titre)
	{
		$titre = strtolower($titre);
		$this->channels[$titre] = new channel($titre, &$this);
		$this->currentchannel = $titre;
	}
	
	function page_switch(&$notebook, $page, $pagenum)
	{
		$tab_label = $this->notebook->get_tab_label($this->notebook->get_nth_page($pagenum));
		$children = $tab_label->children();
		$label = $children[1];
		$msg_on = gdk::pixmap_create_from_xpm($this->window->window, null, '../irc_chatter/msg_on.xpm');
		$children[0]->set($msg_on[0], $msg_on[1]);
		$this->currentchannel = $label->get();
		
			$tab_label = @$this->notebook->get_tab_label($this->notebook->get_nth_page($this->notebook->get_current_page()));
			if ($tab_label) {
			    $children = $tab_label->children();
				$msg_off = gdk::pixmap_create_from_xpm($this->window->window, null, '../irc_chatter/msg_off.xpm');
				$children[0]->set($msg_off[0], $msg_off[1]);
			}
		
	}
	
	function new_pv($distantuser)
	{
		$this->pvs[$distantuser] = new pv($distantuser, &$this);
	}
	
	
}

class channel
{
var $name;
var $console;
var $userlist;
var $users = array();
var $i;
var $msg_on;
var $msg_off;
var $pixwid;
var $lastclickedname;
var $parentclass;

	function channel($titre, &$parentclass)
	{
		$this->i = 1;
		$this->parentclass = &$parentclass;
		
		$titre = strtolower($titre);
		$child = &new GtkFrame($titre);
		$child->set_border_width(5);
		
		$box3 = &new GtkHBox();
		$this->console = &new GtkText;
		$scrollbar = &new GtkVScrollbar($this->console->vadj);
		$this->console->set_editable(false);
		$this->console->set_word_wrap(true);
		$box3->pack_start($this->console, true, true, 5);
		$box3->pack_end($scrollbar, false);
		
		if ($titre != "status") {
			$hbox = &new GtkVBox();
			$this->userlist = &new GtkCList(1, array(translation("utilisateurs")));
			$this->userlist->columns_autosize();
			$scrolled_win = &new gtkscrolledwindow();
			$scrolled_win->set_policy(GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
			$scrolled_win->add($this->userlist);
			$hbox->pack_start($scrolled_win);
			$button = &new GtkButton(":: ".translation("Fermer le channel")." ::");
			$hbox->pack_end($button, false, false, 5);
			$box3->pack_start($hbox, false, true, 5);
			$this->userlist->connect_after( "select-row", array(&$this, "list_item_clicked"), &$this->parentclass);
		}
		
		$child->add($box3);
		
		$label_box = &new GtkHBox(false, 0);
		$this->msg_on = gdk::pixmap_create_from_xpm($parentclass->window->window, null, '../irc_chatter/msg_on.xpm');
		$this->msg_off = gdk::pixmap_create_from_xpm($parentclass->window->window, null, '../irc_chatter/msg_off.xpm');
		$this->pixwid = &new GtkPixmap($this->msg_off[0], $this->msg_off[1]);
		$label_box->pack_start($this->pixwid, false, true, 0);
		$this->pixwid->set_padding(3, 1);
		$label = &new GtkLabel($titre);
		$label_box->pack_start($label, false, true, 0);
		$label_box->show_all();
		
		$this->parentclass->notebook->append_page($child, $label_box);
		$page = $this->parentclass->notebook->page_num($child);
		$child->show_all();
		$this->parentclass->notebook->set_page($this->parentclass->notebook->page_num($child));
		$this->name = $titre;
		
		if ($titre != "status") {
		    $button->connect("clicked", array(&$this, "remove_page"), &$this->parentclass, $this->name);
		}
	}
	
	function list_item_clicked()
	{
		$selection = $this->userlist->selection; 
		$row = $this->userlist->Get_Row_Data($selection[0]);
		$clickedname = $this->userlist->get_text($selection[0], 0);
		if ($this->lastclickedname == $clickedname) {
			$this->parentclass->new_pv($clickedname);
		}
		$this->lastclickedname = $clickedname;
	}
	
	function remove_page($button, &$parentclass, $name)
	{
		$parentclass->send("PART :".$parentclass->currentchannel."\r\n");
		$parentclass->notebook->remove_page($parentclass->notebook->get_current_page());
	}
	
}

class pv
{
var $distantuser;
var $console;
var $entry;
var $parentclass;
var $pvwindow;

	function pv($distantuser, &$parentclass)
	{
		$this->distantuser = $distantuser;
		$this->parentclass = &$parentclass;
			
		$this->pvwindow = &new GtkWindow;
		$this->pvwindow->set_usize('400', '300');
		$this->pvwindow->set_title("PV : $distantuser");
		$this->pvwindow->connect("destroy", array(&$this, "destroy_pv"));
		
		$dgbox = &new GtkVBox(false, 10);
		$dgbox->set_border_width(10);
		$this->pvwindow->add($dgbox);
		
		$dhbox = &new GtkHBox;
		$this->console = &new GtkText;
		$dscrollbar = &new GtkVScrollbar($this->console->vadj);
		$this->console->set_editable(false);
		$this->console->set_word_wrap(true);
		$dhbox->pack_start($this->console, true, true, 5);
		$dhbox->pack_end($dscrollbar, false);
		$dgbox->pack_start($dhbox);
		
		$this->entry = &new GtkEntry();
		$dgbox->pack_start($this->entry, false, false);
		
		$this->pvwindow->show_all();
		
		$this->entry->connect_after("activate", array(&$this, "parse_pv_command"), $this->distantuser);
	}
	
	
	function parse_pv_command()
	{
		$msg = $this->entry->get_text();
		$this->entry->set_text("");
		$distantuser = $this->distantuser;
		$this->parentclass->send("PRIVMSG $distantuser :$msg\r\n");
		$this->parentclass->display_pv($this->parentclass->nick.": ".$msg."\r\n", $distantuser, true);
	}
	
	function destroy_pv()
	{
		$this->pvwindow->destroy();
		$this->parentclass->pvs[$this->distantuser] = null;
	}
}

class quizz
{
var $timeout;
var $liste = array();
var $parentclass;
var $chan;
var $questionsposees = array();
var $qno;
var $gagnants = array();

	function quizz($file, $chan, &$parentclass)
	{
		$this->qno = null;
		srand((double)microtime()*1000000);
		$this->parentclass = &$parentclass;
		$this->chan = $chan;
		
		$fp = fopen("../irc_chatter/$file", "r");
		$contenu = fread($fp, filesize("../irc_chatter/$file"));
		fclose($fp);
		$lignes = explode("\n", $contenu);
		
		foreach ($lignes as $ligne)
		{
			@isset($ligne[0]) ? null : ($ligne[0] = null);
			if ($ligne[0] != "#" && $ligne) {
				$ligne = str_replace("\r", "", $ligne);
			    $liste = explode(":", $ligne);
				$this->liste[] = array("question" => $liste[0], "reponse" => $liste[1], "points" => $liste[2]);
			}
		}
		
		shuffle($this->liste);
		
		$this->parentclass->display(translation("Le quizz est lanc ! Tapez !stop pour l'arrter")."\r\n", "usertext", $this->chan);
		$this->new_question();
	}
	
	function new_question()
	{
		if ($qno >= (count($this->liste))) {
			$this->end_quizz();
			$this = null;
			return;
			break;
		}
				
		$this->qno++;
		
		$question = $this->liste[$this->qno]["question"];
		$points = $this->liste[$this->qno]["points"];
		$this->parentclass->display(translation("Question")." : $question ($points ".translation("points")."). ".translation("Tapez votre rponse")."\r\n", "usertext", $this->chan);
		$this->parentclass->send("PRIVMSG {$this->chan} :".translation("Question")." : $question ($points ".translation("points")."). ".translation("Tapez !reponse suivi de votre rponse")."\r\n");
		$this->questionsposees[$this->qno] = true;
		$this->timeout = gtk::timeout_add(30000, array(&$this, "end_question"));
	}
	
	function end_question()
	{
		$this->parentclass->display(translation("Dommage, personne n'a trouv ! La rponse tait")." {$this->liste[$this->qno]['reponse']}\r\n", "usertext", $this->chan);
		$this->parentclass->send("PRIVMSG {$this->chan} :".translation("Dommage, personne n'a trouv ! La rponse tait")." {$this->liste[$this->qno]['reponse']}\r\n");
		$this->new_question();
	}
	
	function end_quizz()
	{
		gtk::timeout_remove($this->timeout);
		$this->parentclass->display(translation("Le quizz est termin")."\r\n", "usertext", $this->chan);
		$this->parentclass->send("PRIVMSG {$this->chan} :".translation("Le quizz est termin")."\r\n");
		$top5 = array();
		foreach ($this->gagnants as $cle => $val)
		{
			$top5[$val] .= ", $cle";
		}
		krsort($top5);
		$this->parentclass->display(translation("Rsultats")."\r\n", "usertext", $this->chan);
		$this->parentclass->send("PRIVMSG {$this->chan} :".translation("Rsultats")."\r\n");
		
		$i = 0;
		foreach ($top5 as $cle => $val)
		{
			$no = $i+1;
			$text = "n$no : ".substr($val, 2)." ($cle ".translation("points").")";
			$this->parentclass->display("$text\r\n", "usertext", $this->chan);
			$this->parentclass->send("PRIVMSG {$this->chan} :$text\r\n");
			$i++;
		}
		
	}
	
	function try_response($reponse, $user)
	{
		if (!strcasecmp($reponse, $this->liste[$this->qno]["reponse"])) {
		    $this->gagnants[$user] += $this->liste[$this->qno]["points"];
			gtk::timeout_remove($this->timeout);
			$this->parentclass->display("$user ".translation("a trouv la bonne rponse")."\r\n", "usertext", $this->chan);
			$this->parentclass->send("PRIVMSG {$this->chan} :".translation("Bravo")." $user, ".translation("tu as trouv la bonne rponse")."\r\n");
			$this->new_question();
		}
	}
	
	function points($user)
	{
		$this->parentclass->send("PRIVMSG $user :".translation("vous avez actuellement")." {$this->gagnants[$user]} ".translation("points")."\r\n");
	}
}
?>
